Recommendations - Update
Update the state of a Recommendation
PATCH https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Advisor/recommendations/{recommendationId}?api-version=2026-10-01
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
recommendation
|
path | True |
string |
The recommendation ID. |
|
subscription
|
path | True |
string (uuid) |
The ID of the target subscription. The value must be an UUID. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Request Body
| Name | Type | Description |
|---|---|---|
| properties |
The properties for recommendation patch payload. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Azure operation completed successfully. |
|
| Other Status Codes |
An unexpected error response. |
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| user_impersonation | impersonate your user account |
Examples
PatchRecommendationStateProperties
Sample request
PATCH https://management.azure.com/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/providers/Microsoft.Advisor/recommendations/2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b45?api-version=2026-10-01
{
"properties": {
"recommendationStatus": "Postponed",
"postponedUntilDateTime": "2026-11-12T00:00:00Z"
}
}
Sample response
{
"id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/availabilitysets/armavset/providers/Microsoft.Advisor/recommendations/2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b45",
"name": "2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b45",
"properties": {
"category": "HighAvailability",
"impact": "Medium",
"impactedField": "Microsoft.Compute/availabilitysets",
"impactedValue": "armavset",
"recommendationStatus": "Postponed",
"postponedUntilDateTime": "2026-11-12T00:00:00Z",
"lastUpdated": "2026-10-12T00:00:00Z",
"shortDescription": {
"problem": "Add one or more virtual machines to this availability set to ensure high availability",
"solution": "Add one or more virtual machines to this availability set to ensure high availability"
},
"resourceMetadata": {
"resourceId": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/availabilitysets/armavset"
}
},
"type": "Microsoft.Advisor/recommendations"
}
Definitions
| Name | Description |
|---|---|
| Category |
The category of the recommendation. |
| Control |
The sub-category of the recommendation. |
|
created |
The type of identity that created the resource. |
|
Error |
The resource management error additional info. |
|
Error |
The error detail. |
|
Error |
Error response |
| Impact |
The business impact of the recommendation. |
| Priority |
The Priority of the Recommendation. |
|
Recommendation |
The reason for dismissing the Recommendation. |
|
Recommendation |
The recommendation patch payload. |
|
Recommendation |
The Workload that this Resource belongs to. |
|
Recommendation |
The Review that this Recommendation belongs to. |
|
Recommendation |
Properties for recommendation state patch payload. |
|
Recommendation |
The state of the Recommendation applicable from v2026-02-01-preview. |
|
Resource |
Recommendation resource metadata |
|
Resource |
Advisor Recommendation. |
| Risk |
The potential risk of not implementing the recommendation. |
|
Short |
A summary of the recommendation. |
|
system |
Metadata pertaining to creation and last modification of the resource. |
|
Tracked |
The tracked properties of a Recommendation |
Category
The category of the recommendation.
| Value | Description |
|---|---|
| HighAvailability | |
| Security | |
| Performance | |
| Cost | |
| OperationalExcellence |
Control
The sub-category of the recommendation.
| Value | Description |
|---|---|
| HighAvailability | |
| BusinessContinuity | |
| DisasterRecovery | |
| Scalability | |
| MonitoringAndAlerting | |
| ServiceUpgradeAndRetirement | |
| Other | |
| PrioritizedRecommendations | |
| Personalized |
createdByType
The type of identity that created the resource.
| Value | Description |
|---|---|
| User | |
| Application | |
| ManagedIdentity | |
| Key |
ErrorAdditionalInfo
The resource management error additional info.
| Name | Type | Description |
|---|---|---|
| info |
object |
The additional info. |
| type |
string |
The additional info type. |
ErrorDetail
The error detail.
| Name | Type | Description |
|---|---|---|
| additionalInfo |
The error additional info. |
|
| code |
string |
The error code. |
| details |
The error details. |
|
| message |
string |
The error message. |
| target |
string |
The error target. |
ErrorResponse
Error response
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
Impact
The business impact of the recommendation.
| Value | Description |
|---|---|
| High | |
| Medium | |
| Low |
Priority
The Priority of the Recommendation.
| Value | Description |
|---|---|
| Critical | |
| High | |
| Medium | |
| Low | |
| Informational |
RecommendationDismissReason
The reason for dismissing the Recommendation.
| Value | Description |
|---|---|
| ExcessiveCostInvestmentRequired | |
| TooComplexOrImpracticalToImplement | |
| AnAlternativeSolutionIsAlreadyInPlace | |
| IncompatibleWithTheCurrentConfiguration | |
| ImplementationStepsAreUnclear | |
| RiskIsAcceptable | |
| Other |
RecommendationPatchPayload
The recommendation patch payload.
| Name | Type | Description |
|---|---|---|
| properties |
The properties for recommendation patch payload. |
RecommendationPropertiesResourceWorkload
The Workload that this Resource belongs to.
| Name | Type | Description |
|---|---|---|
| id |
string |
The Id of the Workload |
| name |
string |
The Name of the Workload |
RecommendationPropertiesReview
The Review that this Recommendation belongs to.
| Name | Type | Description |
|---|---|---|
| id |
string |
The ARM Resource Id of the Review |
| name |
string |
The Name of the Review |
RecommendationStatePropertiesPayload
Properties for recommendation state patch payload.
| Name | Type | Description |
|---|---|---|
| postponedUntilDateTime |
string (date-time) |
The time the Recommendation was postponed until. |
| recommendationDismissReason |
The reason the state of the Recommendation was changed. |
|
| recommendationStatus |
The state of the recommendation. |
RecommendationStatus
The state of the Recommendation applicable from v2026-02-01-preview.
| Value | Description |
|---|---|
| New | |
| Postponed | |
| Dismissed | |
| Completed |
ResourceMetadata
Recommendation resource metadata
| Name | Type | Description |
|---|---|---|
| action |
management.azure.com.advisor.recommendations.update |
The action to view resource. |
| plural |
string |
The plural user friendly name of resource type. eg: virtual machines |
| resourceId |
string |
Azure resource Id of the assessed resource |
| singular |
string |
The singular user friendly name of resource type. eg: virtual machine |
| source |
string |
Source from which recommendation is generated |
ResourceRecommendationBase
Advisor Recommendation.
| Name | Type | Description |
|---|---|---|
| id |
string (arm-id) |
Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}" |
| name |
string |
The name of the resource |
| properties.actions |
Recommendation |
The list of recommended actions to implement recommendation. |
| properties.category |
The category of the recommendation. |
|
| properties.completionType |
string |
The type of recommendation completion, which is either MarkedByUser or SystemVerified |
| properties.control |
The sub-category of the recommendation. |
|
| properties.createdTime |
string (date-time) |
The created time of the recommendation. |
| properties.description |
string |
The detailed description of recommendation. |
| properties.exposedMetadataProperties |
management.azure.com.advisor.recommendations.update |
The recommendation metadata properties exposed to customer to provide additional information. |
| properties.extendedProperties |
object |
Extended properties |
| properties.impact |
The business impact of the recommendation. |
|
| properties.impactedField |
string |
The resource type identified by Advisor. |
| properties.impactedValue |
string |
The resource identified by Advisor. |
| properties.label |
string |
The label of recommendation. |
| properties.lastRefreshed |
string (date-time) |
The most recent time Advisor evaluated the recommendation for validity (re-ingested). |
| properties.lastUpdated |
string (date-time) |
The most recent time the recommendation state changed (manual or automated). |
| properties.learnMoreLink |
string |
The link to learn more about recommendation and generation logic. |
| properties.metadata |
management.azure.com.advisor.recommendations.update |
The recommendation metadata. |
| properties.notes |
string |
Additional notes for the Recommendation |
| properties.postponedUntilDateTime |
string (date-time) |
The time the Recommendation was postponed until. |
| properties.potentialBenefits |
string |
The potential benefit of implementing recommendation. |
| properties.recommendationDismissReason |
The reason the Recommendation was dismissed. |
|
| properties.recommendationStatus |
The state of the Recommendation |
|
| properties.recommendationTypeId |
string |
The recommendation-type GUID. |
| properties.remediation |
management.azure.com.advisor.recommendations.update |
The automated way to apply recommendation. |
| properties.resourceMetadata |
Metadata of resource that was assessed |
|
| properties.resourceWorkload |
The Workload that this Resource belongs to. |
|
| properties.review |
The Review that this Recommendation belongs to. |
|
| properties.risk |
The potential risk of not implementing the recommendation. |
|
| properties.shortDescription |
A summary of the recommendation. |
|
| properties.sourceSystem |
string |
The Source System that this Recommendation originated from. |
| properties.suppressionId |
string |
The single snoozed or dismissed rule for the recommendation. |
| properties.trackedProperties |
The properties of a tracked recommendation. |
|
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
|
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
Risk
The potential risk of not implementing the recommendation.
| Value | Description |
|---|---|
| Error | |
| Warning | |
| None |
ShortDescription
A summary of the recommendation.
| Name | Type | Description |
|---|---|---|
| problem |
string |
The issue or opportunity identified by the recommendation and proposed solution. |
| solution |
string |
The issue or opportunity identified by the recommendation and proposed solution. |
systemData
Metadata pertaining to creation and last modification of the resource.
| Name | Type | Description |
|---|---|---|
| createdAt |
string (date-time) |
The timestamp of resource creation (UTC). |
| createdBy |
string |
The identity that created the resource. |
| createdByType |
The type of identity that created the resource. |
|
| lastModifiedAt |
string (date-time) |
The timestamp of resource last modification (UTC) |
| lastModifiedBy |
string |
The identity that last modified the resource. |
| lastModifiedByType |
The type of identity that last modified the resource. |
TrackedRecommendationProperties
The tracked properties of a Recommendation
| Name | Type | Description |
|---|---|---|
| priority |
The Priority of the Recommendation. |